<template lang="pug">
#editor
	p {{seleccion.x}}
	p {{seleccion.y}}
	#documento(ref="documento")
		#t1.texto titulo
		img#img01.imagen(src="https://www.tetonas.me/wp-content/uploads/2019/02/Abella-Danger-1.jpg")
		img#img02.imagen(src="https://mui.today/__export/1568939766602/sites/mui/img/2019/09/19/45416361002_60d398fdaa_b.jpg_691115875.jpg")
		#t2.texto titulo
	svg#control(
			ref="control",
			xmlns="http://www.w3.org/2000/svg",
			viewBox="0 0 640 640",
			@click="controlClick",

			@mousedown="controlMouseDown",
			@mousemove="controlMouseMove",
			@mouseup="arrastrando = false",
			@mouseleave="arrastrando = false",
		)
		//- @click="controlClick",
		rect.seleccion(
			:x="seleccion.x",
			:y="seleccion.y",
			:width="seleccion.width",
			:height="seleccion.height"
		)
	#propiedades()
		h3 Propiedades

</template>

<script>
export default {
	data(){
		return {
			elemento: null,
			arrastrando: false,
			ratonDesplazamiento: {
				x: 0,
				y: 0
			}
		}
	},
	computed:{
		seleccion(){
			let rectangulo = {
				x: 0,
				y: 0,
				width: 0,
				height: 0
			};

			if(this.elemento){

				const documento = this.$refs.documento.getBoundingClientRect()
				const elemento = this.elemento.getBoundingClientRect()

				rectangulo.x = elemento.x - documento.x
				rectangulo.y = elemento.y - documento.y
				rectangulo.width = elemento.width
				rectangulo.height = elemento.height
			}

			return rectangulo
		}
	},
	methods:{
		controlClick(evt){
			// const elementos = document.elementsFromPoint(evt.clientX, evt.clientY)

			// this.elemento = elementos.find( elem => elem.classList.contains("elemento"))
		},
		controlMouseDown(evt){
			const elementos = document.elementsFromPoint(evt.clientX, evt.clientY)

			this.elemento = elementos.find( elem => elem.classList.contains("elemento"))

			this.arrastrando = true
			const CTM = this.$refs.control.getScreenCTM()
			console.log(CTM)
			console.log(this.ratonDesplazamiento.x,this.ratonDesplazamiento.y)
			console.log(evt.clientX, evt.clientY)
			console.log(CTM.e, CTM.a, CTM.f, CTM.d)
			console.log(this.seleccion.x, this.seleccion.y)
			// this.ratonDesplazamiento = {
			// 	x: ((evt.clientX - CTM.e) / CTM.a),
			// 	y: ((evt.clientY - CTM.f) / CTM.d)
			// }

			this.ratonDesplazamiento.x = ((evt.clientX - CTM.e) / CTM.a) - this.seleccion.x;
			this.ratonDesplazamiento.y = ((evt.clientY - CTM.f) / CTM.d) - this.seleccion.y;

		},
		controlMouseMove(evt) {
			if (this.elemento && this.arrastrando) {
				// console.debug(evt)
				evt.preventDefault()
				const CTM = this.$refs.control.getScreenCTM()
				const x = ((evt.clientX - CTM.e) / CTM.a) - this.ratonDesplazamiento.x
				const y = ((evt.clientY - CTM.f) / CTM.d) - this.ratonDesplazamiento.y
				// const x = evt.clientX
				// const y = evt.clientY
				// console.log(x, y)
				this.elemento.style.left = `${x}px`
				this.elemento.style.top = `${y}px`

				// this.$refs.control.setAttributeNS(null, "x", x);
				// this.$refs.control.setAttributeNS(null, "y", y);
			}
		}
	},

	mounted(){
		const doc = this.$refs.documento
		doc.children.forEach( elem => {
			//console.log(elem);
			elem.classList.add("elemento")
		})
		const control = this.$refs.control

	}
}


</script>


<style lang="stylus" scoped>
#editor
	background grey
	position absolute
	top 0
	left 0
	right 0
	bottom 0

	width 100%
	height 100%

#documento
	background white
	border 1px solid black
	width 640px
	height 640px
	position absolute
	top 0
	left 0
	right 0
	bottom 0
	margin auto
	overflow hidden

	*
		outline 1px solid blue

	.texto
		position absolute
		top 0
		left 0
		text-align left

	.imagen
		max-width 100%
		max-height 100%
		position absolute
		top 0
		left 0

#control
	position absolute
	top 0
	left 0
	right 0
	bottom 0

	width 640px
	height 640px
	// background grey
	margin auto

	.seleccion
		fill transparent
		stroke-width 1px
		stroke red
		transition all 150ms


</style>
